const XLSX = require('xlsx');
const program = require('commander');
const fs = require('fs-extra');
const ejs = require('ejs');
var plantuml = require('node-plantuml');

var file, sheet, interactions,out;
program
  .version("0.1.0")
  .description(
    "Extracts data from a spreadsheet to make architecture (component) diagrams"
  )
  .option("-c, --component-template [comp]", "EJS template to render components")
  .option("-f --output-format [format]", "Output format [png|svg] - defaults to png", "png")
  .arguments("<excel> <datasheet> <interfaces> <outputname>")
  .action((excel, datasheet, interfaces, outputname) => {file = excel ; sheet = datasheet; interactions = interfaces; out=outputname })
program.parse(process.argv);

async function main(file, sheet, program) {
    const tmp = await fs.readFile(program.componentTemplate, "utf-8");
    const compTemplate = ejs.compile(tmp);
    var workbook = XLSX.readFile(file);
    const data = XLSX.utils.sheet_to_json(workbook.Sheets[sheet]);
    const integrations = XLSX.utils.sheet_to_json(workbook.Sheets["Integrations"]);

    const diagram = compTemplate({sheet: data, int: integrations})
    const outFile = `${out}.txt`
    const img = `${out}.${program.outputFormat}`
    await fs.writeFileSync(outFile, diagram);
    var gen = plantuml.generate(outFile);
    gen.out.pipe(fs.createWriteStream(img));
    console.log("Outputting: ", img);
    
    //console.log(diagram); 
}

main(file, sheet, program);


